## ncbi-vdb 3.0.9+dfsg

=== test/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

if(NOT CMAKE_TEST_OUTPUT_DIRECTORY)
    set(CMAKE_TEST_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/test-bin)
endif()
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_TEST_OUTPUT_DIRECTORY} )

if ( "GNU" STREQUAL "${CMAKE_C_COMPILER_ID}")
    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable" )
endif()

add_subdirectory(kfc)

set( COMMON_LINK_LIBRARIES ktst kapp )
set( ADDITIONAL_LIBS "" )

# for the tests that link against libncbi-[w]vdb
if( WIN32 )
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ENTRY:wmainCRTStartup")
    set( COMMON_LIBS_READ  ${COMMON_LINK_LIBRARIES} ncbi-vdb Ws2_32 Crypt32 ${MBEDTLS_LIBS} )
    set( COMMON_LIBS_WRITE ${COMMON_LINK_LIBRARIES} ncbi-wvdb Ws2_32 Crypt32 ${MBEDTLS_LIBS} )
else()
    link_libraries( ${COMMON_LINK_LIBRARIES} )
    set( COMMON_LIBS_READ  ncbi-vdb  dl pthread ${MBEDTLS_LIBS} )
    set( COMMON_LIBS_WRITE ncbi-wvdb dl pthread ${MBEDTLS_LIBS} )
endif()


add_subdirectory(ktst)
add_subdirectory(cc)
add_subdirectory(ext)
add_subdirectory(judy_test)
add_subdirectory(klib)
add_subdirectory(kfs)
add_subdirectory(kfg)
add_subdirectory(kapp)
add_subdirectory(cloud)
add_subdirectory(krypto)
add_subdirectory(cipher)
add_subdirectory(kdb)
add_subdirectory(kproc)
add_subdirectory(vdb)
add_subdirectory(search)
add_subdirectory(sraxf)
add_subdirectory(vxf)
add_subdirectory(axf)
add_subdirectory(schema) # TODO: INT_TOOLS - see the schema CMakeLists.txt for the details
add_subdirectory(vfs)
add_subdirectory(ncbi-vdb)
# add_subdirectory(install)
add_subdirectory(kns) # TODO: EXT_TOOLS - see the kns CMakeLists.txt for the details
add_subdirectory(align)

# add_subdirectory(loader) VDB-4855 moved to sra-tools/libs
# add_subdirectory(align) moved to sra-tools
# add_subdirectory(align-access) #VDB-4140 moved to asm-trace

=== libs/kdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( KDB_CMN
    btree
#    rowset
#    rowset-simple

    kdb-cmn
    rkdb
    wkdb

    dbmgr-cmn
    manager-base
    database-base
    table-base
    column-base
    columnblob-base
    meta-base
    metanode-base
    index-base

    ptrieval-v1
    ptrieval-v2

    idstats

    database-cc
    table-cc
    column-cc
    dbcc-cmn

    trieval-v1
    trieval-v2

    index-cmn

    rindex
    ridxblk
    rtrieidx-v1
    rtrieidx-v2
    ru64idx-v3

    windex
    widxblk
    wtrieidx-v1
    wtrieidx-v2
    wu64idx-v3

    rcolumn
    rcolumnblob

    wcolumn
    wcolumnblob

    rmeta
    rmetadatanode

    wmeta
    wmetadatanode

    rcoldata
    rcolidx
    rcolidx0
    rcolidx1
    rcolidx2

    wcoldata
    wcolidx
    wcolidx0
    wcolidx1
    wcolidx2

    rdbmgr
    rtable
    rdatabase

    wdbmgr
    wdatabase
    wtable
)

set( KDB_SRC
    ${KDB_CMN}
)

set( WKDB_SRC
    ${KDB_CMN}
)


GenerateStaticLibs( kdb "${KDB_SRC}" )
GenerateStaticLibs( wkdb "${WKDB_SRC}" )

add_compile_definitions (__mod__="libs/kdb")

=== libs/klib/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set ( UNIX_BASE_SRC unix/misc.c unix/syslog.c unix/systime.c unix/syswriter.c )
set ( UNIX_SRC ${UNIX_BASE_SRC} unix/syserrcode.c )
set ( LINUX_SRC ${UNIX_BASE_SRC} linux/syserrcode.c )
set ( MAC_SRC ${UNIX_SRC} )
set ( WIN_SRC win/misc.c win/sysalloc.c win/syserrcode.c win/syslog.c win/systime.c win/syswriter.c )

if ( "windows" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${WIN_SRC} )
elseif( "linux" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${LINUX_SRC} )
elseif( "mac" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${MAC_SRC} )
endif()

if( FLEX_FOUND AND BISON_FOUND )
    # the generated files have names prefized with zz_ to make sure they get checked out last
    # in order to prevent unneeded invokation of bison and flex
    FLEX_TARGET( JsonFlex json-lex.l ${CMAKE_CURRENT_SOURCE_DIR}/zz_json-lex.c
        COMPILE_FLAGS "--debug --noline" )
    set( JsonScanner ${FLEX_JsonFlex_OUTPUTS} )
    BISON_TARGET( JsonGrammar json-grammar.y ${CMAKE_CURRENT_SOURCE_DIR}/zz_json-grammar.c
        COMPILE_FLAGS "-Wno-other --no-lines -r state --defines=${CMAKE_CURRENT_SOURCE_DIR}/zz_json-grammar.h" )
    set( JsonParser ${BISON_JsonGrammar_OUTPUT_SOURCE} )
    ADD_FLEX_BISON_DEPENDENCY(JsonFlex JsonGrammar)
    SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM 1)
else()
    set( JsonScanner zz_json-lex.c )
    set( JsonParser zz_json-grammar.c )
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set( BUILD_SPECIFIC_SRC debug.c )
else()
    set( BUILD_SPECIFIC_SRC release.c )
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")

add_subdirectory( judy )

set( SRC
    all-vdb-version
    base64
    bsearch
    bstpersist #TODO: bstpersist.nopt
    btree
    container
    cp1252
    crc32
    data-buffer
    guid
    hashfile # TODO: dead code
    hashtable # TODO: dead code
    iso8859-1
    iso8859
    ${JsonParser}
    ${JsonScanner}
    json
    judy-vector
    ksort
    log
    md5
    namelist
    num-gen
    out
    pack
    # NOTE:
    # pbstree-impl.nopt pbstree-native.c ptpersist.nopt ptrie.nopt
    # were generated by the old gmake build but are not used anywhere, apparently
    pbstree-impl
    pbstree-swapped.c # was 'pbstree-impl.swap.nopt' in the old gmake build
    pbstree
    #
    printf
    progressbar
    ptpersist
    ptrie
    qsort
    rc-idx-tbl
    rc-tbl
    refcount
    report-klib
    SHA-32bit
    SHA-64bit
    sra-release-version
    status-rc-strings
    status-rc
    status
    symtab
    text
    time
    token
    trie
    unpack
    utf8
    vector
    vector_namelist
    vlen-encode
    writer
    ${BUILD_SPECIFIC_SRC}
    ${OS_SPECIFIC_SRC}
)

# suppress certain compiler warnings
if ( "GNU" STREQUAL "${CMAKE_C_COMPILER_ID}")
    set_source_files_properties( container judy-vector ptrie PROPERTIES COMPILE_FLAGS -Wstrict-aliasing=0 )
elseif ( CMAKE_C_COMPILER_ID MATCHES "^(Apple)?Clang$" )
    set_source_files_properties( out PROPERTIES COMPILE_FLAGS -Wno-string-compare )
endif()

GenerateStaticLibs( klib "${SRC}" )

add_compile_definitions (__mod__="libs/klib")
add_compile_definitions (_ARCH_BITS=${BITS})
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} )

=== libs/ktst/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set ( UNIX_SRC unix/systestenv )
set ( LINUX_SRC ${UNIX_SRC} )
set ( MAC_SRC ${UNIX_SRC} )
set ( WIN_SRC win/systestenv )

if ( "windows" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${WIN_SRC} )
elseif( "linux" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${LINUX_SRC} )
elseif( "mac" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${MAC_SRC} )
endif()

set( SRC
    testenv
    testcase
    testrunner
    ${OS_SPECIFIC_SRC}
)

GenerateStaticLibs( ktst "${SRC}" )
ExportStatic( ktst true )

add_compile_definitions (__mod__="libs/ktst")
if ( WIN32 )
    # warning C5039: 'XXX': pointer or reference to potentially throwing function passed to extern C function under -EHc. Undefined behavior may occur if this function throws an exception.
    set_source_files_properties(testenv.cpp PROPERTIES COMPILE_FLAGS "/wd5039")
endif()

=== libs/ncbi-vdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# all static libraries in this directory are published

set( VDB_LIB_CMN_TARGETS
    align-access
    ncbi-bam
    vfs
    cloud
    kns
    kfg
    krypto
    ksrch
    kfs
    klib
    judy
    kproc
    kq
    kfc
    schema
)
if ( HAVE_MBEDTLS_F )
    message("Using mbedtls installed in the system")
else()
    message("No mbedtls libs found installed in the system, using local copy...")
    list( APPEND VDB_LIB_CMN_TARGETS mbedx509 mbedtls mbedcrypto )
endif()

if(NOT _NCBIVDB_CFG_PACKAGING)
    list( APPEND VDB_LIB_CMN_TARGETS bz2 z zstd )
endif()

set( VDB_LIB_RD_TARGETS
    ${VDB_LIB_CMN_TARGETS}
    align-reader
    srareader
    sradb
    vdb-blast
    vdb
    kdb
    axf
    sraxf
    wgsxf
    vxf
)

set( VDB_LIB_RDWR_TARGETS
    ${VDB_LIB_CMN_TARGETS}
    align-writer
    wsradb
    wvdb
    wkdb
    waxf
    wsraxf
    wwgsxf
    wvxf
)

if( WIN32 )
    include( CMakeLists.win.txt )
elseif( SINGLE_CONFIG )
    include( CMakeLists.posix.txt )
    if(NOT _NCBIVDB_CFG_PACKAGING)
	add_custom_command( TARGET ncbi-vdb POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/interfaces/kfg/ncbi/default.kfg ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ncbi/default.kfg
	)
	add_custom_command( TARGET ncbi-vdb POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/interfaces/kfg/ncbi/default.kfg ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/ncbi/default.kfg
	)
	add_custom_command( TARGET ncbi-vdb POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/interfaces/kfg/ncbi/certs.kfg ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ncbi/certs.kfg
	)
	add_custom_command( TARGET ncbi-vdb POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/interfaces/kfg/ncbi/certs.kfg ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/ncbi/certs.kfg
	)
    endif()
else() # XCode
    list(REMOVE_ITEM VDB_LIB_RD_TARGETS bz2 z)
    list(REMOVE_ITEM VDB_LIB_RDWR_TARGETS bz2 z)
    include( CMakeLists.xcode.txt )
endif()

=== libs/vdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( VDBCMN_SRC
    dbmgr-cmn
    schema-tok
    schema-parse
    schema-type
    schema-func
    schema-prod
    schema-expr
    schema-eval
    schema-tbl
    schema-view
    schema-db
    schema-dump
    schema-int
    schema
    linker-int
    linker-cmn
    database-cmn
    database-depend
    database-load
    table-cmn
    table-load
    cursor-cmn
    column-cmn
    prod-cmn
    prod-expr
    prod-func
    phys-cmn
    phys-load
    blob
    blob-headers
    page-map
    row-id
    row-len
    fixed-row-len
    merge
    split
    compare
    meta-read
    meta-value
    meta-attr-read
    cast
    range-validate
    parameter-read
    redimension
    index_project
    index_lookup
    transpose
    delta_average
    report-vdb
    bytecode
    view
    cursor-view
    cursor-table
)

set( VDB_SRC
    ${VDBCMN_SRC}
    dbmgr
    linker
    database
    table
    cursor
    column
    prod
    phys
)

set( WVDB_SRC
    ${VDBCMN_SRC}
    wdbmgr
    wlinker
    wdatabase
    wtable
    wcursor
    wcolumn
    wprod
    wphys
    meta-write
    meta-attr-write
    meta-append
    index_insert
)

GenerateStaticLibs( vdb "${VDB_SRC}" )
GenerateStaticLibs( wvdb "${WVDB_SRC}" )

# suppress certain compiler warnings
if ( "GNU" STREQUAL "${CMAKE_C_COMPILER_ID}")
    set_target_properties( vdb wvdb PROPERTIES COMPILE_FLAGS -Wstrict-aliasing=0 )
elseif ( "Clang" STREQUAL "${CMAKE_C_COMPILER_ID}")
    set_source_files_properties( cast PROPERTIES COMPILE_FLAGS -Wno-implicit-int-float-conversion )
endif()

add_compile_definitions (__mod__="libs/vdb")

=== test/kdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

if( WIN32 )
    set( ADDITIONAL_LIBS Crypt32 )
	set( TMPDIR ./data)
else()
    set( ADDITIONAL_LIBS "" )
	set( TMPDIR /tmp )
endif()

# TODO: make sure runs are not cached in the user repository when running tests

add_compile_definitions( __mod__="test/kdb" )

AddExecutableTest( Test_KDB_Setup "makedb" "${COMMON_LIBS_WRITE}" )

set_tests_properties(Test_KDB_Setup PROPERTIES FIXTURES_SETUP Kdb)

# AddExecutableTest( Test_KDB_Btree "test-btree" "${COMMON_LIBS_READ}" ) #TODO: revive test-btree
# AddExecutableTest( Test_KDB_Rowset "rowsettest" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" ) # not in use

AddExecutableTest( Test_KDB_KRColumn "test-rcolumn" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_KWColumn "test-wcolumn" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_KRTable "test-rtable" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_KWTable "test-wtable" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_KRDatabase "test-rdatabase" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_KWDatabase "test-wdatabase" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_KRManager "test-rmanager" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_KWManager "test-wmanager" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_KRMetadata "test-rmetadata" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_KWMetadata "test-wmetadata" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_KRMDataNode "test-rmetanode" "${COMMON_LIBS_READ}" )
set_tests_properties(Test_KDB_KRMDataNode PROPERTIES FIXTURES_REQUIRED Kdb)

AddExecutableTest( Test_KDB_KWMDataNode "test-wmetanode" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_KRIndex "test-rindex" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_KWIndex "test-windex" "${COMMON_LIBS_WRITE}" )

AddExecutableTest( Test_KDB_Kdb "kdbtest" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KDB_Wkdb "wkdbtest" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )

AddExecutableTest( Test_KDB_CopyColumn "VDB-4705" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
set_property(TEST Test_KDB_CopyColumn PROPERTY ENVIRONMENT "TMPDIR=${TMPDIR}")

AddExecutableTest( Test_KDB_CopyMeta "VDB-4706" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
set_property(TEST Test_KDB_CopyMeta PROPERTY ENVIRONMENT "TMPDIR=${TMPDIR}")

AddExecutableTest( Test_KDB_Index "VDB-5323" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
set_property(TEST Test_KDB_Index PROPERTY ENVIRONMENT "TMPDIR=${TMPDIR}")

=== test/kns/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

add_compile_definitions( __mod__="test/kns" )

AddExecutableTest( Test_KNS_allow_all_certificates "test_allow_all_certificates" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_dis_allow_all_certificates "test_dis_allow_all_certificates" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_aws-proxy "test-aws-proxy" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_google-proxy "test-google-proxy" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_test200for-whole-file "test200for-whole-file" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS "knstest" "${COMMON_LIBS_READ}" )
AddExecutableTest( SlowTest_KNS_ipc "test-ipc" "${COMMON_LIBS_READ}" )
AddExecutableTest( SlowTest_KNS_http "HttpFixture;httptest" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_http-dropconn "http_dropconnection_test" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_http_request "HttpFixture;test-http-request" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_KNSManagerSingletonTest "KNSManagerSingletonTest" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_connect "HttpFixture;test-connect" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_refresh-expired "HttpFixture;KStableHttpFile;test-refresh-expired-url" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_KNS_timeouts "test-timeouts" "${COMMON_LIBS_READ}" )

# TODO the following binaries are not unit tests (EXT_TOOLS), they should be started not as ctest

BuildExecutableForTest( test-kns-mutual-authentication "test-mutual-authentication;gosha" "${COMMON_LIBS_READ}" )
# add_test( NAME Test_KNS_mutual-authentication COMMAND test-kns-mutual-authentication WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )

BuildExecutableForTest( test-kns-proxy-with-env "test-proxy-with-env" "${COMMON_LIBS_READ}" )
# add_test( NAME Test_KNS_proxy-with-env COMMAND test-kns-proxy-with-env WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )

if( SINGLE_CONFIG )

    BuildExecutableForTest( Test_KNS_proxy "test-proxy" "${COMMON_LIBS_READ}" )
    add_test( NAME Test_KNS_proxy COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-proxy.sh ${CMAKE_TEST_OUTPUT_DIRECTORY}/Test_KNS_proxy WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )

    BuildExecutableForTest( Test_KNS_proxy-with-scheme_dflt "test-proxy-with-scheme" "${COMMON_LIBS_READ}" )
    add_test( NAME Test_KNS_proxy-with-scheme_dflt COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-proxy-with-scheme.sh ${CMAKE_TEST_OUTPUT_DIRECTORY}/Test_KNS_proxy-with-scheme_dflt WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )
    #set_tests_properties(Test_KNS_proxy-with-scheme PROPERTIES ENVIRONMENT http_proxy=)

endif()

AddExecutableTest( Test_KNS_proxy-with-scheme_failure "test-proxy-with-scheme_failure" "${COMMON_LIBS_READ}" )

=== test/schema/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

add_compile_definitions( __mod__="test/schema" )
#set( CMAKE_DISABLE_SOURCE_CHANGES OFF )
file( MAKE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/actual ) # TODO remove ./actual dir after tests pass (add_test POST?)
#set( CMAKE_DISABLE_SOURCE_CHANGES ON ) # Cannot use with bison

AddExecutableTest( Test_SCHEMA_wb-schema-lex "wb-test-schema-lex" "${COMMON_LIBS_READ};schema" )
AddExecutableTest( Test_SCHEMA_wb-schema-parser "wb-test-schema-parser" "${COMMON_LIBS_READ};schema" )
AddExecutableTest( Test_SCHEMA_wb-schema-ast "wb-test-schema-ast;AST_Fixture" "${COMMON_LIBS_READ};schema" )
AddExecutableTest( Test_SCHEMA_wb-test-schema-func "wb-test-schema-func;AST_Fixture" "${COMMON_LIBS_READ};schema" )
AddExecutableTest( Test_SCHEMA_wb-test-schema-table "wb-test-schema-table;AST_Fixture" "${COMMON_LIBS_READ};schema" )
AddExecutableTest( Test_SCHEMA_wb-test-schema-db "wb-test-schema-db;AST_Fixture" "${COMMON_LIBS_READ};schema" )
AddExecutableTest( Test_SCHEMA_wb-test-schema-view "wb-test-schema-view;AST_Fixture" "${COMMON_LIBS_READ};schema" )

# TODO the following binaries are not unit tests (INT_TOOLS), they should be started not as ctest

if( SINGLE_CONFIG )
    BuildExecutableForTest( Test_SCHEMA_schema-scan "test-schema-scan" "${COMMON_LIBS_READ};schema" )
    add_test( NAME Test_SCHEMA_schema-scan COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-schema-scan.sh ${CMAKE_TEST_OUTPUT_DIRECTORY}/Test_SCHEMA_schema-scan ${CMAKE_SOURCE_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )

    BuildExecutableForTest( Test_SCHEMA_schema-parse "test-schema-parse" "${COMMON_LIBS_READ};schema" )
    add_test( NAME Test_SCHEMA_schema-parse COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-schema-parse.sh ${CMAKE_TEST_OUTPUT_DIRECTORY}/Test_SCHEMA_schema-parse ${CMAKE_SOURCE_DIR}  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )

    BuildExecutableForTest( Test_SCHEMA_schema-diff "test-schema-diff" "${COMMON_LIBS_READ};schema" )
    add_test( NAME Test_SCHEMA_schema-diff COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-schema-diff.sh ${CMAKE_TEST_OUTPUT_DIRECTORY}/Test_SCHEMA_schema-diff ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )
endif()

if (Python3_EXECUTABLE)
    add_custom_target(Build-wso ALL )
    add_dependencies(Build-wso ncbi-wvdb-shared)

    add_test( NAME Test_SCHEMA_454_db
        COMMAND ${Python3_EXECUTABLE} test_VDB-5250.py
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
    set_tests_properties( Test_SCHEMA_454_db
        PROPERTIES
        ENVIRONMENT VDB_LIBRARY_PATH=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
    )

    add_test( NAME Test_SCHEMA_IonTorrent_db
        COMMAND ${Python3_EXECUTABLE} test_VDB-5251.py
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
    set_tests_properties( Test_SCHEMA_IonTorrent_db
        PROPERTIES
        ENVIRONMENT VDB_LIBRARY_PATH=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
    )
endif()

=== test/vdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

add_compile_definitions( __mod__="test/vdb" )

if( WIN32 )
    set( ADDITIONAL_LIBS Crypt32 )
else()
    set( ADDITIONAL_LIBS "" )
endif()

AddExecutableTest( SlowTest_VDB_vdb "test-vdb" "${COMMON_LIBS_READ}" )

AddExecutableTest( Test_VDB_wvdb "test-wvdb" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
set_tests_properties(Test_VDB_wvdb PROPERTIES ENVIRONMENT VDB_CONFIG=${CMAKE_CURRENT_SOURCE_DIR}/kfg/empty)

# temp disable test
AddExecutableTest( Test_VDB_pagemap "test-pagemap" "${COMMON_LIBS_WRITE}" )

AddExecutableTest(
         SlowTest_VDB_dependencies_dflt "test-dependencies_dflt" "${COMMON_LIBS_READ}" )
AddExecutableTest(
 Test_VDB_dependencies_404first "Test_VDB_dependencies_404first" "${COMMON_LIBS_READ}" )
AddExecutableTest(
           Test_VDB_dependencies_wgs "Test_VDB_dependencies_wgs" "${COMMON_LIBS_READ}" )

AddExecutableTest( Test_VDB_sparse_col_rw "test-sparse-col" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
set_tests_properties( Test_VDB_sparse_col_rw PROPERTIES FIXTURES_SETUP SPARSE_COL )

AddExecutableTest( Test_VDB_sparse_col_rd "test-sparse-col" "${COMMON_LIBS_READ}" )
target_compile_definitions(Test_VDB_sparse_col_rd PUBLIC READ_ONLY)
set_tests_properties(Test_VDB_sparse_col_rd PROPERTIES FIXTURES_REQUIRED SPARSE_COL )
if( RUN_SANITIZER_TESTS )
    target_compile_definitions(Test_VDB_sparse_col_rd_asan PUBLIC READ_ONLY)
    set_tests_properties(Test_VDB_sparse_col_rd_asan PROPERTIES FIXTURES_REQUIRED SPARSE_COL)
    target_compile_definitions(Test_VDB_sparse_col_rd_tsan PUBLIC READ_ONLY)
    set_tests_properties(Test_VDB_sparse_col_rd_tsan PROPERTIES FIXTURES_REQUIRED SPARSE_COL)
endif()

AddExecutableTest( Test_VDB_blob_val "test-blob-val" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VDB_VDB-3060 "test-VDB-3060" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VDB_VDB-3061 "test-VDB-3061" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VDB_bytecode "test-bytecode" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
AddExecutableTest( Test_VDB_database_cmn "test-database-cmn" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
AddExecutableTest( Test_VDB_view "test-view" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS};schema" )
AddExecutableTest( Test_VDB_wtablecursor "test-wtablecursor" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
AddExecutableTest( Test_VDB_view_cursor "test-view-cursor" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS};schema" )
AddExecutableTest( Test_VDB_VDB-4156 "test-VDB-4156" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
AddExecutableTest( Test_VDB_META_CMP_COPY "test-vdb-meta-cmp-copy" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )
AddExecutableTest( Test_VDB_schema_priv "Test-VDB_schema_priv" "${COMMON_LIBS_READ};${ADDITIONAL_LIBS}" )
AddExecutableTest( Test_VDB_link "test-link" "${COMMON_LIBS_READ}" )

# Slow tests
AddExecutableTest( SlowTest_VDB_tablecursor "test-tablecursor" "${COMMON_LIBS_READ}" )
AddExecutableTest( SlowTest_VDB_vdb-slow "test-vdb-slow" "${COMMON_LIBS_READ}" )
AddExecutableTest( SlowTest_VDB_wvdb-slow "test-wvdb-slow" "${COMMON_LIBS_WRITE};${ADDITIONAL_LIBS}" )

# TODO: make sure runs are not cached in the user repository when running tests

# TODO: valgrind

=== test/vfs/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

add_compile_definitions( __mod__="test/vfs" )

AddExecutableTest( Test_VFS_attached-vdbcache "test-attached-vdbcache" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_log-names-error "test-log-names-error" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_redirect-rejected-names-cgi-http-to-https "redirect-rejected-names-cgi-http-to-https.cpp" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_resolver-with-log "test-resolver-with-log" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_sdl-response "test-sdl-response" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_services "test-services" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_SraDesc "test-SraDesc" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_cache_sdl "test_VFS_cache_sdl" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_caching "test-caching" "${COMMON_LIBS_READ}" )
# AddExecutableTest( Test_VFS_names-30 "test-names-30" "${COMMON_LIBS_READ}" )
AddExecutableTest(Test_VFS_no-nm-cgi "Test_VFS_no-nm-cgi" "${COMMON_LIBS_READ}")
AddExecutableTest( Test_VFS_path "pathtest" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_path-c "path-test" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_perm "test-perm" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_resolve "test-resolve" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_resolver_dflt "Test_VFS_resolver_dflt" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_vfsmanager "managertest" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_json-response "test-json-response" "${COMMON_LIBS_READ}" )
# AddExecutableTest( Test_VFS_resolver4 "test-resolver4" "${COMMON_LIBS_READ}" )
AddExecutableTest( Test_VFS_resolve-qual "test-resolve-qual" "${COMMON_LIBS_READ}" )

=== debian/changelog ===
ncbi-vdb (3.0.9+dfsg-2) unstable; urgency=medium

  * Upload to unstable to join Mbed TLS 3.x.  (Closes: #1075868.)
  * debian/salsa-ci.yml: Comment out aptly setup, no longer needed.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 17 Oct 2024 22:35:54 -0400

ncbi-vdb (3.0.9+dfsg-1) experimental; urgency=medium

  [ Andreas Tille ]
  * New upstream version

  [ Aaron M. Ucko ]
  * debian/control: Version libmbedtls-dev B-D to (>= 3), so far available
    only in experimental, to match recent versions' usage.
  * debian/patches/system_mbedtls_3.patch (new): Reinstate test for system
    mbed TLS, tweaking it to accept (and moreover require) 3.x.
  * debian/salsa-ci.yml: Reenable aptly per the need to target
    experimental again for now.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 11 Apr 2024 17:40:20 -0400

=== debian/control ===
Source: ncbi-vdb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs (>= 0.104)
Build-Depends-Arch: cmake,
                    libbz2-dev,
                    libxml2-dev,
                    libmagic-dev,
                    libmbedtls-dev (>= 3),
                    zlib1g-dev,
                    libzstd-dev,
                    flex,
                    bison,
                    python3,
                    doxygen,
                    graphviz,
                    chrpath
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-vdb
Vcs-Git: https://salsa.debian.org/med-team/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb
Rules-Requires-Root: no

Package: libncbi-vdb3
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ncbi-vdb-data (>= ${source:Version})
Breaks: sra-toolkit (<< 2.11~)
Description: libraries for using data in the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains a runtime library for reading VDB data.

Package: libncbi-vdb-dev
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-vdb3 (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         libzstd-dev,
         zlib1g-dev
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This is the development package for reading VDB data.

Package: ncbi-vdb-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Breaks: libncbi-vdb2 (<< 2.11.2+dfsg-5~)
Replaces: libncbi-vdb2 (<< 2.11.2+dfsg-5~)
Description: schemata and defaults for the INSDC Sequence Read Archives
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains VDB schemata for SRA data and default
 configuration files for VDB libraries.

Package: libncbi-wvdb3
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ncbi-vdb-data (>= ${source:Version})
Description: virtual layer update module of ncbi-vdb library
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains a runtime library for updating VDB data.

Package: libncbi-wvdb-dev
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb3 (= ${binary:Version})
Description: virtual layer update module of ncbi-vdb library (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This package contains development files for updating VDB data.

Package: libsam-extract3
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SAM extraction module of ncbi-vdb library
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides an interface
 for extracting Sequence/Alignment Map (SAM) files.

Package: libsam-extract-dev
Architecture: amd64 arm64 x32
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsam-extract3 (= ${binary:Version})
Description: SAM extraction module of ncbi-vdb library (devel)
 The (US) National Center for Biotechnology Information (NCBI)'s
 Virtual/Vertical Database (VDB) is a highly compressed column-oriented
 data warehousing technology developed initially to address the needs
 of the Sequence Read Archive (SRA). It is unique in that it builds
 databases from smaller parts that can function independently as
 _documents_, supports effective and efficient compression, supports
 encryption while remaining encrypted on disk, transparent distribution
 and remote access.
 .
 This library is part of the ncbi-vdb package and provides development
 files for extracting Sequence/Alignment Map (SAM) files.
